#pragma once

#include <vector>

#include "gamestate.h"

#include "LD12.h"
#include "Level.h"
#include "GameObject.h"




class CGSGame : public CGameState
{

  public:

    std::list<GameObject>   m_CurrentSetup;

    std::vector<LD12::GameObjectType>   m_AvailableItems;
    std::map<std::pair<int,int>,LD12::TileTypes>   m_BuiltItems;

    Level                   m_Level;

    bool                    m_ButtonReleased;

    int                     m_CurLevel;

    GameObject*             m_pCurrentObject;

    size_t                  m_CurrentItem;

    int                     m_CurrentStartDelay;

    bool                    m_BuildUpMode;
    bool                    m_Done;

    bool                    m_DraggingBomb;

    int                     m_Money;
    int                     m_MoneyAtLevelStart;
    int                     m_DamageDone;

    float                   m_DisplayNameTime;


    CGSGame();
    virtual ~CGSGame();

    virtual void            Display( IDirect3DDevice8* pDevice );

    virtual void            UpdateFrame( const float fElapsedTime );

    virtual void            OnChar( int iChar );
    virtual void            OnKeyDown( int iChar );
    virtual void            OnMouse( int iX, int iY, int iButtons );
    virtual void            OnMouseWheel( int Delta );

    void                    PrepareLevel( int Level );

    int                     ItemPrice( LD12::GameObjectType Type );

    void                    RecalcStructures();
    int                     CalculateOtherDamage();

    void                    RetryLevel();

};
