#include <d3d8.h>

#include ".\GSInstructions.h"
#include ".\GSMenu.h"
#include ".\LD12.h"



CGSInstructions::CGSInstructions() :
  m_ButtonReleased( false ),
  m_CurPage( 0 )
{

  m_Level.Load( 254 );

}



CGSInstructions::~CGSInstructions()
{
}



void CGSInstructions::Display( IDirect3DDevice8* pDevice )
{

  m_Level.Render();

  theApp.m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );

  theApp.PrintNiceCentered( 320, 20, "INSTRUCTIONS" );

  if ( m_CurPage == 0 )
  {
    theApp.PrintNice( 20,  70, "WELCOME TO YOUR STARTUP COMPANY \"TOWER WRECKERS LTD.\"" );
    theApp.PrintNice( 20, 110, "YOUR JOB IS TO RAZE ABANDONED BUILDINGS. YOU ARE GIVEN" );
    theApp.PrintNice( 20, 150, "A CERTAIN AMOUNT OF MONEY AND YOU HAVE TO USE IT WISELY" );
    theApp.PrintNice( 20, 190, "TO BUY NEEDED OBJECTS." );
    theApp.PrintNice( 20, 230, "SIMPLE BOMBS WILL DAMAGE ANYTHING IN THEIR VICINITY." );
    theApp.PrintNice( 20, 270, "SOMETIMES OTHER BUILDINGS NEARBY WILL NEED TO BE" );
    theApp.PrintNice( 20, 310, "PROTECTED FROM THE FLYING DEBRIS." );
  }
  else if ( m_CurPage == 1 )
  {
    theApp.PrintNice( 20,  70, "TO PLACE AN OBJECT SIMPLY DRAG IT FROM THE BOTTOM BAR" );
    theApp.PrintNice( 20, 110, "AND DROP IT AT THE TARGET SPACE." );
    theApp.PrintNice( 20, 150, "USE THE BUTTONS TO THE LEFT TO SWITCH BETWEEN OBJECTS." );
    theApp.PrintNice( 20, 190, "HOVER OVER THE OBJECT ICON TO READ ABOUT USE AND PRICE." );
    theApp.PrintNice( 20, 230, "BOMBS ALLOW A TIMER WHICH YOU CAN ADJUST WITH THE" );
    theApp.PrintNice( 20, 270, "BUTTONS TO THE RIGHT." );
  }
  else if ( m_CurPage == 2 )
  {
    theApp.PrintNice( 20,  70, "PLASTIC AND WOODEN SHEETINGS ALLOW TO BUILD A SHIELDING" );
    theApp.PrintNice( 20, 110, "FROM THE FLYING DEBRIS. THEY MUST BE BUILT ON TOP OF" );
    theApp.PrintNice( 20, 150, "SOMETHING THOUGH." );
  }

  if ( m_CurPage < 2 )
  {
    theApp.RenderButton( 320 + 5, 380, 120, 40, LD12::TEX_GUI_BUTTON_1, LD12::TEX_GUI_BUTTON_2, LD12::TEX_GUI_BUTTON_3 );
    theApp.PrintNiceCentered( 320 + 5 + 60, 385, "NEXT" );
  }

  theApp.RenderButton( 320 + 5 + 120 + 10, 380, 120, 40, LD12::TEX_GUI_BUTTON_1, LD12::TEX_GUI_BUTTON_2, LD12::TEX_GUI_BUTTON_3 );
  theApp.PrintNiceCentered( 320 + 5 + 120 + 10 + 60, 385, "QUIT" );

}



void CGSInstructions::UpdateFrame( const float fElapsedTime )
{

}



void CGSInstructions::OnChar( int iChar )
{

  if ( ( iChar == 27 )
  ||   ( iChar == ' ' )
  ||   ( iChar == 13 ) )
  {
    theApp.NextState( new CGSMenu() );
  }

}



void CGSInstructions::OnKeyDown( int iChar )
{

}



void CGSInstructions::OnMouse( int X, int Y, int Buttons )
{

  int   ButtonYOffset = 380;

  if ( ( Buttons & 1 )
  &&   ( m_ButtonReleased ) )
  {
    m_ButtonReleased = false;

    if ( ( theApp.m_MouseX >= 320 + 5 )
    &&   ( theApp.m_MouseX < 320 + 5 + 120 )
    &&   ( theApp.m_MouseY >= ButtonYOffset )
    &&   ( theApp.m_MouseY < ButtonYOffset + 40 ) )
    {
      if ( m_CurPage < 2 )
      {
        ++m_CurPage;
      }
    }
    if ( ( theApp.m_MouseX >= 320 + 5 + 120 + 10 )
    &&   ( theApp.m_MouseX < 320 + 5 + 120 + 10 + 120 )
    &&   ( theApp.m_MouseY >= ButtonYOffset )
    &&   ( theApp.m_MouseY < ButtonYOffset + 40 ) )
    {
      if ( theApp.m_MouseButtons & 1 )
      {
        OnChar( 27 );
      }
    }
  }

  if ( !( Buttons & 1 ) )
  {
    m_ButtonReleased = true;
  }

}



