#include <d3d8.h>

#include ".\gsmenu.h"
#include ".\LD12.h"
#include ".\GSEdit.h"
#include ".\GSGame.h"
#include ".\GSInstructions.h"



CGSMenu::CGSMenu() :
  m_ButtonReleased( true )
{

  m_Level.Load( 255 );

}

CGSMenu::~CGSMenu(void)
{
}



void CGSMenu::Display( IDirect3DDevice8* pDevice )
{

  m_Level.Render();

  theApp.m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );

  theApp.PrintNiceCentered( 321, 71, "TOWER COLLAPSE", 0xff000000 );
  theApp.PrintNiceCentered( 320, 70, "TOWER COLLAPSE" );
  theApp.PrintNiceCentered( 321, 101, "DETONATOR PART II", 0xff000000 );
  theApp.PrintNiceCentered( 320, 100, "DETONATOR PART II", 0xffffd000 );

  theApp.PrintNiceCentered( 320, 160, "Ludum Dare #12" );
  theApp.PrintNiceCentered( 320, 190, "Georg \"Endurion\" Rottensteiner" );

  theApp.PrintNiceCentered( 320, 250, "http://www.georg-rottensteiner.de" );

  theApp.RenderButton( 320 - 5 - 120 - 10 - 120, 380, 120, 40, LD12::TEX_GUI_BUTTON_1, LD12::TEX_GUI_BUTTON_2, LD12::TEX_GUI_BUTTON_3 );
  theApp.PrintNiceCentered( 320 - 5 - 120 - 10 - 120 + 60, 385, "PLAY" );

  theApp.RenderButton( 320 - 5 - 120, 380, 120, 40, LD12::TEX_GUI_BUTTON_1, LD12::TEX_GUI_BUTTON_2, LD12::TEX_GUI_BUTTON_3 );
  theApp.PrintNiceCentered( 320 - 5 - 120 + 60, 385, "INFO" );

  theApp.RenderButton( 320 + 5, 380, 120, 40, LD12::TEX_GUI_BUTTON_1, LD12::TEX_GUI_BUTTON_2, LD12::TEX_GUI_BUTTON_3 );
  theApp.PrintNiceCentered( 320 + 5 + 60, 385, "EDIT" );

  theApp.RenderButton( 320 + 5 + 120 + 10, 380, 120, 40, LD12::TEX_GUI_BUTTON_1, LD12::TEX_GUI_BUTTON_2, LD12::TEX_GUI_BUTTON_3 );
  theApp.PrintNiceCentered( 320 + 5 + 120 + 10 + 60, 385, "QUIT" );

  int   ButtonYOffset = 380;

}



void CGSMenu::UpdateFrame( const float fElapsedTime )
{

  m_Level.Update( fElapsedTime );

}



void CGSMenu::OnMouse( int X, int Y, int Buttons )
{

  int   ButtonYOffset = 380;

  if ( ( Buttons & 1 )
  &&   ( m_ButtonReleased ) )
  {
    m_ButtonReleased = false;

    if ( ( theApp.m_MouseX >= 320 - 5 - 120 - 10 - 120 )
    &&   ( theApp.m_MouseX < 320 - 5 - 120 - 10 - 120 + 120 )
    &&   ( theApp.m_MouseY >= ButtonYOffset )
    &&   ( theApp.m_MouseY < ButtonYOffset + 40 ) )
    {
      if ( theApp.m_MouseButtons & 1 )
      {
        OnChar( 'p' );
      }
    }
    if ( ( theApp.m_MouseX >= 320 - 5 - 120 )
    &&   ( theApp.m_MouseX < 320 - 5 - 120 + 120 )
    &&   ( theApp.m_MouseY >= ButtonYOffset )
    &&   ( theApp.m_MouseY < ButtonYOffset + 40 ) )
    {
      if ( theApp.m_MouseButtons & 1 )
      {
        OnChar( 'i' );
      }
    }
    if ( ( theApp.m_MouseX >= 320 + 5 )
    &&   ( theApp.m_MouseX < 320 + 5 + 120 )
    &&   ( theApp.m_MouseY >= ButtonYOffset )
    &&   ( theApp.m_MouseY < ButtonYOffset + 40 ) )
    {
      if ( theApp.m_MouseButtons & 1 )
      {
        OnChar( 'e' );
      }
    }
    if ( ( theApp.m_MouseX >= 320 + 5 + 120 + 10 )
    &&   ( theApp.m_MouseX < 320 + 5 + 120 + 10 + 120 )
    &&   ( theApp.m_MouseY >= ButtonYOffset )
    &&   ( theApp.m_MouseY < ButtonYOffset + 40 ) )
    {
      if ( theApp.m_MouseButtons & 1 )
      {
        OnChar( 27 );
      }
    }
  }

  if ( !( Buttons & 1 ) )
  {
    m_ButtonReleased = true;
  }

}



void CGSMenu::OnChar( int iChar )
{

  if ( iChar == 'e' )
  {
    theApp.NextState( new CGSEdit() );
  }
  else if ( iChar == 'p' )
  {
    theApp.NextState( new CGSGame() );
  }
  else if ( iChar == 'i' )
  {
    theApp.NextState( new CGSInstructions() );
  }
  else if ( iChar == 27 )
  {
    PostMessage( theApp.m_hWnd, WM_CLOSE, 0, 0 );
  }

}



void CGSMenu::OnKeyDown( int iChar )
{

}