#ifndef LD12_TYPES_H
#define LD12_TYPES_H


namespace LD12
{
  enum TextureTypes
  {
    TEX_BOMB,
    TEX_EXPLOSION_1,
    TEX_EXPLOSION_2,
    TEX_EXPLOSION_3,
    TEX_SMOKE_LEFT,
    TEX_SMOKE_RIGHT,
    TEX_SMOKE_LEFT_2,
    TEX_SMOKE_RIGHT_2,
    TEX_SMOKE_LEFT_3,
    TEX_SMOKE_RIGHT_3,
    TEX_PARTICLE_GLASS_1,
    TEX_PARTICLE_BETON_1,
    TEX_PARTICLE_BETON_2,
    TEX_GUI_PLUS_1,
    TEX_GUI_PLUS_2,
    TEX_GUI_PLUS_3,
    TEX_GUI_MINUS_1,
    TEX_GUI_MINUS_2,
    TEX_GUI_MINUS_3,
    TEX_ITEM_PLASTIC_FENCE,
    TEX_ITEM_WOODEN_FENCE,
    TEX_GUI_BUTTON_1,
    TEX_GUI_BUTTON_2,
    TEX_GUI_BUTTON_3,
    TEX_GUI_ARROW_UP,
    TEX_GUI_ARROW_DOWN,
    TEX_SINK,
    TEX_TOILET,

    TEX_LAST_ENTRY
  };

  enum GameObjectType
  {
    GO_TIMEBOMB,
    GO_EXPLOSION,
    GO_PARTICLE_GLASS,
    GO_PARTICLE_BETON,
    GO_SMOKE_LEFT,
    GO_SMOKE_RIGHT,
    GO_WOODEN_FENCE,
    GO_PLASTIC_FENCE,

    GO_LAST_ENTRY
  };

  enum TileTypes
  {
    TILE_EMPTY,
    TILE_GRASS,
    TILE_WINDOW_1,
    TILE_SKY_EMPTY,
    TILE_WINDOW_1_BROKEN_1,
    TILE_WINDOW_1_BROKEN_2,
    TILE_WINDOW_1_BROKEN_3,
    TILE_WINDOW_1_BROKEN_4,
    TILE_WINDOW_1_BROKEN_5,
    TILE_WOODEN_FENCE,
    TILE_WOODEN_FENCE_TOP,
    TILE_PLASTIC_FENCE,
    TILE_PLASTIC_FENCE_RIPPED,
    TILE_OTHER_WINDOW_1,
    TILE_OTHER_WINDOW_1_BROKEN_1,
    TILE_OTHER_WINDOW_1_BROKEN_2,
    TILE_OTHER_WINDOW_1_BROKEN_3,
    TILE_OTHER_WINDOW_1_BROKEN_4,
    TILE_OTHER_WINDOW_1_BROKEN_5,
    TILE_WOODEN_FENCE_BROKEN,
    TILE_WOODEN_FENCE_TOP_BROKEN,

    TILE_LAST_ENTRY
  };

  enum SoundTypes
  {
    SOUND_EXPLOSION,
    SOUND_EXPLOSION_2,
    SOUND_BREAK_GLASS_1,
    SOUND_BREAK_GLASS_2,
    SOUND_BREAK_BETON_1,
    SOUND_COLLAPSE_1,
    SOUND_COLLAPSE_2,
    SOUND_COLLAPSE_3,
    SOUND_HIT_WOODEN_FENCE_1,
    SOUND_HIT_WOODEN_FENCE_2,
    SOUND_HIT_PLASTIC_FENCE_1,
    SOUND_HIT_PLASTIC_FENCE_2,
    SOUND_SET_ITEM,
    SOUND_GET_ITEM,
    SOUND_CANNOT_PUT_ITEM,

    SOUND_LAST_ENTRY
  };
};




#endif // LD12_TYPES_H